// ****************************************************************************
// gestion de deux boutons poussoirs
// Auteur : Morin Pascal
// (C) 1998 -2002
// ****************************************************************************
#include <reg51f.h>
#include <stdio.h>
#include "bpkeyio.h"
#include "bpgetkey.h"


// ****************************************************************************
extern void wait(int);
bit	key_auto_repeat=0;
unsigned char key_delay_count=LOW_SPEED;
unsigned char key_repeat_count=0;


// ****************************************************************************
char bp_get_key(void)
{
char x=0;

while(BP1&&BP2);					// attend qu'une touche soit enfoncee ?
wait(50);							// attente anti-rebonds
while(!(BP1&&BP2))
	{
   if (!BP1) x|=1;
	if (!BP2) x|=2;
	if(key_auto_repeat)
		{
		wait(1);
		if(--key_delay_count==0)
			{
			key_repeat_count++;
			if(key_repeat_count>REPEAT_STEP2) 
					{
					key_delay_count=HIGH_SPEED;									// vitesse rapide
					key_repeat_count=REPEAT_STEP2+1;
					}
			else if(key_repeat_count>REPEAT_STEP1) key_delay_count=MEDIUM_SPEED;	// vitesse moyenne
			else key_delay_count=LOW_SPEED;										// vitesse lente
			return(x);
			}
		}
	else wait(50);						// attente anti-rebonds
	}
key_repeat_count=0;
key_delay_count=LOW_SPEED;
return(x);
}

// ****************************************************************************
bit bp_kbhit(void)
{
if (BP1&&BP2) return(0);		// les touches sont au repos ?
return(1);							// ici au moins une touche est active
}
