//---------------------------------------------------------------------------
#include <vcl.h>
#include <list.h>
#include <stdio.h>
#include <Printers.hpp>
#pragma hdrstop

#include "Unit1.h"
#include "..\cmde.h"
#include "Unit2.h"
#include "Unit3.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
list <item> pgm[16];
list <label> liste_des_labels;
unsigned int ligne_pgm=1;
int pgm_sel=0;
bool modified=false;

TPrinter *p;
int PrintPage;
float PrtYpos;

void traite(char * trame,unsigned int org, FILE *d);


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Quitter1Click(TObject *Sender)
{
Close();    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioActionClick(TObject *Sender)
{
switch(RadioAction->ItemIndex)
    {
    case    0:  // mise en route des moteurs
                EditNbPas->Enabled=false;
                LabelNbPas->Enabled=false;
                EditSpeed->Enabled=false;
                LabelSpeed->Enabled=false;
                LabelSpeed2->Enabled=false;
                CheckDC1->Enabled=true;
                RadioDC1->Enabled=true;
                CheckDC2->Enabled=true;
                RadioDC2->Enabled=true;
                CheckStepper->Enabled=false;
                EditDelais->Enabled=false;
                LabelDelais->Enabled=false;
                EditLabel->Enabled=false;
                LabelLabel->Enabled=false;
                RadioON->Enabled=false;
                RadioOFF->Enabled=false;
                LabelDebug->Enabled=false;
                break;

    case    1:  // mise en route du moteur pas  pas
                EditNbPas->Enabled=true;
                LabelNbPas->Enabled=true;
                EditSpeed->Enabled=true;
                LabelSpeed->Enabled=true;
                LabelSpeed2->Enabled=true;
                CheckDC1->Enabled=false;
                RadioDC1->Enabled=false;
                CheckDC2->Enabled=false;
                RadioDC2->Enabled=false;
                CheckStepper->Enabled=false;
                EditDelais->Enabled=false;
                LabelDelais->Enabled=false;
                EditLabel->Enabled=false;
                LabelLabel->Enabled=false;
                RadioON->Enabled=false;
                RadioOFF->Enabled=false;
                LabelDebug->Enabled=false;
                break;

    case    2:  //Arrets des moteurs
                EditNbPas->Enabled=false;
                LabelNbPas->Enabled=false;
                EditSpeed->Enabled=false;
                LabelSpeed->Enabled=false;
                LabelSpeed2->Enabled=false;
                CheckDC1->Enabled=true;
                RadioDC1->Enabled=false;
                CheckDC2->Enabled=true;
                RadioDC2->Enabled=false;
                CheckStepper->Enabled=true;
                EditDelais->Enabled=false;
                LabelDelais->Enabled=false;
                EditLabel->Enabled=false;
                LabelLabel->Enabled=false;
                RadioON->Enabled=false;
                RadioOFF->Enabled=false;
                LabelDebug->Enabled=false;
                break;

    case    3:  // Mise en roue libre des moteurs
                EditNbPas->Enabled=false;
                LabelNbPas->Enabled=false;
                EditSpeed->Enabled=false;
                LabelSpeed->Enabled=false;
                LabelSpeed2->Enabled=false;
                CheckDC1->Enabled=true;
                RadioDC1->Enabled=false;
                CheckDC2->Enabled=true;
                RadioDC2->Enabled=false;
                CheckStepper->Enabled=true;
                EditDelais->Enabled=false;
                LabelDelais->Enabled=false;
                EditLabel->Enabled=false;
                LabelLabel->Enabled=false;
                RadioON->Enabled=false;
                RadioOFF->Enabled=false;
                LabelDebug->Enabled=false;
                break;

    case    4:  // Attente d'un dlais
                EditNbPas->Enabled=false;
                LabelNbPas->Enabled=false;
                EditSpeed->Enabled=false;
                LabelSpeed->Enabled=false;
                LabelSpeed2->Enabled=false;
                CheckDC1->Enabled=false;
                RadioDC1->Enabled=false;
                CheckDC2->Enabled=false;
                RadioDC2->Enabled=false;
                CheckStepper->Enabled=false;
                EditDelais->Enabled=true;
                LabelDelais->Enabled=true;
                EditLabel->Enabled=false;
                LabelLabel->Enabled=false;
                RadioON->Enabled=false;
                RadioOFF->Enabled=false;
                LabelDebug->Enabled=false;
                break;

    case    5:  // Dfinir un label
                EditNbPas->Enabled=false;
                LabelNbPas->Enabled=false;
                EditSpeed->Enabled=false;
                LabelSpeed->Enabled=false;
                LabelSpeed2->Enabled=false;
                CheckDC1->Enabled=false;
                RadioDC1->Enabled=false;
                CheckDC2->Enabled=false;
                RadioDC2->Enabled=false;
                CheckStepper->Enabled=false;
                EditDelais->Enabled=false;
                LabelDelais->Enabled=false;
                EditLabel->Enabled=true;
                LabelLabel->Enabled=true;
                RadioON->Enabled=false;
                RadioOFF->Enabled=false;
                LabelDebug->Enabled=false;
                break;

    case    6:  // Appel d'un sous programme
                EditNbPas->Enabled=false;
                LabelNbPas->Enabled=false;
                EditSpeed->Enabled=false;
                LabelSpeed->Enabled=false;
                LabelSpeed2->Enabled=false;
                CheckDC1->Enabled=false;
                RadioDC1->Enabled=false;
                CheckDC2->Enabled=false;
                RadioDC2->Enabled=false;
                CheckStepper->Enabled=false;
                EditDelais->Enabled=false;
                LabelDelais->Enabled=false;
                EditLabel->Enabled=true;
                LabelLabel->Enabled=true;
                RadioON->Enabled=false;
                RadioOFF->Enabled=false;
                LabelDebug->Enabled=false;
                break;

    case    7:  //Retour de sous programme
                EditNbPas->Enabled=false;
                LabelNbPas->Enabled=false;
                EditSpeed->Enabled=false;
                LabelSpeed->Enabled=false;
                LabelSpeed2->Enabled=false;
                CheckDC1->Enabled=false;
                RadioDC1->Enabled=false;
                CheckDC2->Enabled=false;
                RadioDC2->Enabled=false;
                CheckStepper->Enabled=false;
                EditDelais->Enabled=false;
                LabelDelais->Enabled=false;
                EditLabel->Enabled=false;
                LabelLabel->Enabled=false;
                RadioON->Enabled=false;
                RadioOFF->Enabled=false;
                LabelDebug->Enabled=false;
                break;

    case    8:  // saut inconditionnel
                EditNbPas->Enabled=false;
                LabelNbPas->Enabled=false;
                EditSpeed->Enabled=false;
                LabelSpeed->Enabled=false;
                LabelSpeed2->Enabled=false;
                CheckDC1->Enabled=false;
                RadioDC1->Enabled=false;
                CheckDC2->Enabled=false;
                RadioDC2->Enabled=false;
                CheckStepper->Enabled=false;
                EditDelais->Enabled=false;
                LabelDelais->Enabled=false;
                EditLabel->Enabled=true;
                LabelLabel->Enabled=true;
                RadioON->Enabled=false;
                RadioOFF->Enabled=false;
                LabelDebug->Enabled=false;
                break;

    case    9:  // Passage en mode debug
                EditNbPas->Enabled=false;
                LabelNbPas->Enabled=false;
                EditSpeed->Enabled=false;
                LabelSpeed->Enabled=false;
                LabelSpeed2->Enabled=false;
                CheckDC1->Enabled=false;
                RadioDC1->Enabled=false;
                CheckDC2->Enabled=false;
                RadioDC2->Enabled=false;
                CheckStepper->Enabled=false;
                EditDelais->Enabled=false;
                LabelDelais->Enabled=false;
                EditLabel->Enabled=false;
                LabelLabel->Enabled=false;
                RadioON->Enabled=true;
                RadioOFF->Enabled=true;
                LabelDebug->Enabled=true;
                break;

    case    10:  // Fin de programme
                EditNbPas->Enabled=false;
                LabelNbPas->Enabled=false;
                EditSpeed->Enabled=false;
                LabelSpeed->Enabled=false;
                LabelSpeed2->Enabled=false;
                CheckDC1->Enabled=false;
                RadioDC1->Enabled=false;
                CheckDC2->Enabled=false;
                RadioDC2->Enabled=false;
                CheckStepper->Enabled=false;
                EditDelais->Enabled=false;
                LabelDelais->Enabled=false;
                EditLabel->Enabled=false;
                LabelLabel->Enabled=false;
                RadioON->Enabled=false;
                RadioOFF->Enabled=false;
                LabelDebug->Enabled=false;
                break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
item x;
AnsiString msg;
list<item>::iterator l;
unsigned int i,sel;
int val;

if (ComboPgm->ItemIndex<0)
    {
    Application->MessageBox("Selectionnez un numro de programme","Erreur de saisie",MB_OK|MB_ICONERROR);
    return;
    }

// determine la position de l'insertion
sel=ListBox1->ItemIndex+1;      // pointe aprs la ligne courante
//if (sel<1) sel=ligne_pgm;       // pointe  la fin si rien n'est selectionn

// remet  zro le contenu de la structure
x.ligne=ligne_pgm;
x.step=0;
x.dc1=false;
x.sens_dc1=false;
x.dc2=false;
x.sens_dc2=false;
x.stepper=false;
x.delais=0;
x.label[0]=0;
x.debug=false;

try
    {
    // determine l'action demande
    switch(RadioAction->ItemIndex)
        {
        case    0:  // mise en route des moteurs DC
                    x.type=CMDE_MOT;
                    x.dc1=CheckDC1->Checked;
                    if (RadioDC1->ItemIndex==0) x.sens_dc1=true;
                    else x.sens_dc1=false;
                    x.dc2=CheckDC2->Checked;
                    if (RadioDC2->ItemIndex==0) x.sens_dc2=true;
                    else x.sens_dc2=false;
                    if ((x.dc1==false)&&(x.dc2==false))
                        {
                        Application->MessageBox("Au moins un moteur doit tre slectionn","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    break;

        case    1:  // mise en route du moteur pas  pas
                    x.type=CMDE_STEPPER;
                    val=StrToInt(EditNbPas->Text);
                    if ((val>127)||(val<-127))
                        {
                        Application->MessageBox("Le nb de pas est limit  +/-127","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    x.step=(char)val;
                    val=StrToInt(EditSpeed->Text);
                    if ((val>255)||(val<0))
                        {
                        Application->MessageBox("Le temps d'attente entre les pas doit tre compris entre 0 et 255 ms","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    x.speed=(unsigned char)val;
                    break;

        case    2:  //Arrets des moteurs
                    x.type=CMDE_STOP;
                    x.dc1=CheckDC1->Checked;
                    x.dc2=CheckDC2->Checked;
                    x.stepper=CheckStepper->Checked;
                    if ((x.dc1==false)&&(x.dc2==false)&&(x.stepper==false))
                        {
                        Application->MessageBox("Au moins un moteur doit tre slectionn","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    break;

        case    3:  // Mise en roue libre des moteurs
                    x.type=CMDE_IDLE;
                    x.dc1=CheckDC1->Checked;
                    x.dc2=CheckDC2->Checked;
                    x.stepper=CheckStepper->Checked;
                    if ((x.dc1==false)&&(x.dc2==false)&&(x.stepper==false))
                        {
                        Application->MessageBox("Au moins un moteur doit tre slectionn","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    break;

        case    4:  // Attente d'un dlais
                    x.type=WAIT;
                    x.delais=StrToInt(EditDelais->Text);
                    if ((x.delais<1)||(x.delais>0x7fff))
                        {
                        Application->MessageBox("Le delai doit tre compris entre 1ms et 32767ms","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    break;

        case    5:  // Dfinir un label
                    x.type=LABEL;
                    if (EditLabel->Text.Length()==0)
                        {
                        Application->MessageBox("Le label doit tre dfini","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    if (EditLabel->Text.Length()>40)
                        {
                        Application->MessageBox("Le label doit tre limit  40 caractres","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    strcpy(x.label,EditLabel->Text.c_str());
                    break;

        case    6:  // Appel d'un sous programme
                    x.type=CALL;
                    if (EditLabel->Text.Length()==0)
                        {
                        Application->MessageBox("Le label doit tre dfini","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    if (EditLabel->Text.Length()>40)
                        {
                        Application->MessageBox("Le label doit tre limit  40 caractres","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    strcpy(x.label,EditLabel->Text.c_str());
                    break;

        case    7:  //Retour de sous programme
                    x.type=RETURN;
                    break;

        case    8:  // saut inconditionnel
                    x.type=JUMP;
                    if (EditLabel->Text.Length()==0)
                        {
                        Application->MessageBox("Le label doit tre dfini","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    if (EditLabel->Text.Length()>40)
                        {
                        Application->MessageBox("Le label doit tre limit  40 caractres","Erreur de saisie",MB_OK|MB_ICONERROR);
                        return;
                        }
                    strcpy(x.label,EditLabel->Text.c_str());
                    break;

        case    9:  // Passage en mode debug
                    x.type=DBG;
                    x.debug=RadioON->Checked;
                    break;

        case    10:  // Fin de programme
                    x.type=CMDE_END;
                    break;
        }

    // pointe sur l'emplacement voulu
    if (sel>pgm[pgm_sel].size())
        {
        pgm[pgm_sel].push_back(x);
        }
    else
        {
        l=pgm[pgm_sel].begin();
        for (i=0;i<sel;i++) l++;
        pgm[pgm_sel].insert(l,x);
        }

    ligne_pgm++;
    RedrawList();
    ListBox1->ItemIndex=sel;
    modified=true;
    }

catch(EConvertError &e)
    {
    Application->MessageBox("Vrifiez la saisie des valeurs numriques","Erreur de saisie",MB_OK|MB_ICONERROR);
    }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::AddListbox(item x, int ligne)
{
AnsiString msg;
switch(x.type)
    {
    case    CMDE_MOT:  // mise en route des moteurs DC
                    msg="Moteur :";
                    if (x.dc1)
                        {
                        if (x.sens_dc1) msg+=" DC1(+)";
                        else msg+=" DC1(-)";
                        }
                    if (x.dc2)
                        {
                        if (x.sens_dc2) msg+=" DC2(+)";
                        else msg+=" DC2(-)";
                        }
                    break;

    case    CMDE_STEPPER:  // mise en route du moteur pas  pas
                    msg=AnsiString("Pas  pas : ")+IntToStr(x.step)+" (t="+IntToStr(x.speed)+" ms entre les pas)";
                    break;

    case    CMDE_STOP:  //Arrets des moteurs
                    msg="Arret :";
                    if (x.dc1) msg+=" DC1";
                    if (x.dc2) msg+=" DC2";
                    if (x.stepper) msg+=" Pas  pas";
                    break;

    case    CMDE_IDLE:  // Mise en roue libre des moteurs
                    msg="Roue libre :";
                    if (x.dc1) msg+=" DC1";
                    if (x.dc2) msg+=" DC2";
                    if (x.stepper) msg+=" Pas  pas";
                    break;

    case    WAIT:  // Attente d'un dlais
                    msg="Attente : "+AnsiString(x.delais)+" (ms)";
                    break;

    case    LABEL:  // Dfinir un label
                    msg="Label: "+AnsiString(x.label);
                    break;

    case    CALL:  // Appel d'un sous programme
                    msg="Appel sous pgm :"+AnsiString(x.label);
                    break;

    case    RETURN:  //Retour de sous programme
                    msg="Retour de sous pgm";
                    break;

    case    JUMP:  // saut inconditionnel
                    msg="Saut en :"+AnsiString(x.label);
                    break;

    case    DBG:  // Passage en mode debug
                    msg="Passage en mode debug = "+ AnsiString((x.debug ? "On" : "Off"));
                    break;

    case    CMDE_END:  // Fin de programme
                    msg="Fin";
                    break;
    }
msg="ligne:" + AnsiString(ligne)+ " ->" + msg;
ListBox1->Items->Add(msg);
ListBox1->ItemIndex=ListBox1->Items->Count-1;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
int sel;
list<item>::iterator l;
int i;

sel=ListBox1->ItemIndex;
if (sel<0)
    {
    Application->MessageBox("Selectionnez la ligne de programme  effacer",
                            "Erreur de saisie",MB_OK|MB_ICONERROR);
    return;
    }

// cre un pointeur (iterator) sur l'lement  effacer
l=pgm[pgm_sel].begin();
for (i=0;i<sel;i++) l++;

pgm[pgm_sel].erase(l);
modified=true;

// raffraichit la liste
RedrawList();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboPgmChange(TObject *Sender)
{
pgm_sel=ComboPgm->ItemIndex;
if (pgm_sel<0)
    {
    MessageBeep(MB_ICONERROR);
    ComboPgm->ItemIndex=0;
    }
RedrawList();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
ComboPgm->ItemIndex=0;
EditNbPas->Enabled=false;
LabelNbPas->Enabled=false;
EditSpeed->Enabled=false;
LabelSpeed->Enabled=false;
LabelSpeed2->Enabled=false;
CheckDC1->Enabled=false;
RadioDC1->Enabled=false;
CheckDC2->Enabled=false;
RadioDC2->Enabled=false;
CheckStepper->Enabled=false;
EditDelais->Enabled=false;
LabelDelais->Enabled=false;
EditLabel->Enabled=false;
LabelLabel->Enabled=false;
RadioON->Enabled=false;
RadioOFF->Enabled=false;
LabelDebug->Enabled=false;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::RedrawList(void)
{
int i;
list<item>::iterator l;

ListBox1->Clear();
i=1;
for (l=pgm[pgm_sel].begin();l!=pgm[pgm_sel].end();l++)
    {
    AddListbox(*l,i++);
    }
ligne_pgm=i;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
if (modified)
    {
    if (Application->MessageBox("Le contenu des programmes a t modifi"
                            "\nVoulez-vous vraiment quitter sans enregistrer?",
                            "Confirmation de sortie",
                            MB_OKCANCEL|MB_ICONEXCLAMATION)!=IDOK) CanClose = false;

    }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Enregistrersous1Click(TObject *Sender)
{
if (SaveDialog1->Execute())
    {
    SaveFile(SaveDialog1->FileName);
    }
}

//---------------------------------------------------------------------------
bool __fastcall TForm1::SaveFile(AnsiString dest)
{
FILE *d;
list<item>::iterator l;
int i,x;

d=fopen(dest.c_str(),"wb");
if (!d)
    {
    Application->MessageBox("Impossible de crer le fichier","Erreur lors de l'enregistrement",MB_OK|MB_ICONERROR);
    return(false);
    }
// procede  l'enregistrement pour chaque programme
for (i=0;i<16;i++)
    {
    x=pgm[i].size();
    fwrite(&i,sizeof(i),1,d); // enregistre le numro du programme
    fwrite(&x,sizeof(x),1,d); // enregistre le nb d'items
    for (l=pgm[i].begin();l!=pgm[i].end();l++)
        {
        fwrite(&(*l),sizeof(item),1,d);
        }
    }
fclose(d);
modified=false;
return(true);
}


//---------------------------------------------------------------------------
bool __fastcall TForm1::OpenFile(AnsiString src)
{
int i,j,n,a;
item x;
FILE * s;

s=fopen(src.c_str(),"rb");
if (!s)
    {
    Application->MessageBox("Impossible d'ouvrir le fichier","Erreur lors de la lecture",MB_OK|MB_ICONERROR);
    return(false);
    }

// procede  la lecture pour chaque programme
for (i=0;i<16;i++)
    {
    fread(&n,sizeof(n),1,s);    // relit le n du programme
    if (n!=i)
        {
        Application->MessageBox("Le contenu du fichier n'est pas cohrent","Erreur lors de la lecture",MB_OK|MB_ICONERROR);
        return(false);
        }
    fread(&n,sizeof(n),1,s);    // lecture du nb d'items
    for(j=0;j<n;j++)            // lecture des items
        {
        a=fread(&x,sizeof(item),1,s);
        if (a!=1)
            {
            Application->MessageBox("Le contenu du fichier n'est pas cohrent","Erreur lors de la lecture",MB_OK|MB_ICONERROR);
            return(false);
            }
        pgm[i].push_back(x);
        }
    }
ComboPgm->ItemIndex=0;
RedrawList();
modified=false;
return(true);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Ouvrir1Click(TObject *Sender)
{
int i;
if (modified)
    {
    if (Application->MessageBox("Le contenu des programmes a t modifi"
                            "\nVoulez-vous vraiment tout effacer ?",
                            "Confirmation d'effacement",
                            MB_OKCANCEL|MB_ICONEXCLAMATION)!=IDOK) return;
    }

for (i=0;i<16;i++)
    {
    pgm[i].clear();
    }
ComboPgm->ItemIndex=0;
RedrawList();
modified=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Ouvrir2Click(TObject *Sender)
{
int i;

if (OpenDialog1->Execute())
    {
    for (i=0;i<16;i++) pgm[i].clear();  // efface les programmes prcedants
    OpenFile(OpenDialog1->FileName);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Apropos1Click(TObject *Sender)
{
OKRightDlg->ShowModal();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Verifier1Click(TObject *Sender)
{
Form3->ShowModal();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Compiler1Click(TObject *Sender)
{
unsigned char * code_pgm;
list<item>::iterator x;
int i,j,pc;
AnsiString msg;
unsigned int addr=0,org;
unsigned char a;
unsigned int pgm_start[16];
FILE *dest;
FILE *hex;
char buff[129];



// alloue le buffer pour le code des programmes
code_pgm=new unsigned char[0x8000];
for (i=0;i<0x8000;i++) code_pgm[i]=0xff;

// contruit la liste des labels avec leur valeur
BuildLabelListe();

// compile les programmes
pc=0;
for (i=0;i<16;i++)      // scan tout les programmes
    {
    if (pgm[i].size())
        pgm_start[i]=pc;    // mmorise le point de dpart du programme
    else pgm_start[i]=0x7fff;

    for (x=pgm[i].begin();x!=pgm[i].end();x++)
        {
        if (pc>0x7fff)
            {
            msg="La taille des programmes dpasse les capacits de la mmoire de l'appareil";
            ListBox1->Items->Add(msg);
            delete code_pgm;
            return;
            }
        switch((*x).type)
            {
            case CMDE_END:      code_pgm[pc++]=CMDE_END;
                                break;

            case CMDE_STOP:     code_pgm[pc++]=CMDE_STOP;
                                a=0;
                                if ((*x).dc1) a|=0x01;
                                if ((*x).dc2) a|=0x02;
                                if ((*x).stepper) a|=0x04;
                                code_pgm[pc++]=a;
                                break;

            case CMDE_STEPPER:  code_pgm[pc++]=CMDE_STEPPER;
                                code_pgm[pc++]=(*x).step;
                                code_pgm[pc++]=(*x).speed;
                                break;

            case CMDE_MOT:      code_pgm[pc++]=CMDE_MOT;
                                a=0;
                                if ((*x).dc1) a|=0x01;
                                if ((*x).sens_dc1) a|=0x02;
                                if ((*x).dc2) a|=0x04;
                                if ((*x).sens_dc2) a|=0x08;
                                code_pgm[pc++]=a;
                                break;

            case WAIT:          code_pgm[pc++]=WAIT;
                                code_pgm[pc++]=(unsigned char)((*x).delais/256);
                                code_pgm[pc++]=(unsigned char)((*x).delais&0x00ff);
                                break;

            case CALL:          code_pgm[pc++]=CALL;
                                if (!FindLabelValue((*x).label,addr))
                                    {
                                    msg="La taille des programmes dpasse les capacits de la mmoire de l'appareil";
                                    ListBox1->Items->Add(msg);
                                    delete code_pgm;
                                    return;
                                    }
                                code_pgm[pc++]=(unsigned char)(addr/256);
                                code_pgm[pc++]=(unsigned char)(addr&0x00ff);
                                break;

            case RETURN:        code_pgm[pc++]=RETURN;
                                break;

            case JUMP:          code_pgm[pc++]=JUMP;
                                if (!FindLabelValue((*x).label,addr))
                                    {
                                    msg="La taille des programmes dpasse les capacits de la mmoire de l'appareil";
                                    ListBox1->Items->Add(msg);
                                    delete code_pgm;
                                    return;
                                    }
                                code_pgm[pc++]=(unsigned char)(addr/256);
                                code_pgm[pc++]=(unsigned char)(addr&0x00ff);
                                break;

            case DBG:           code_pgm[pc++]=DBG;
                                if ((*x).debug) code_pgm[pc++]=1;
                                else code_pgm[pc++]=0;
                                break;

            case CMDE_IDLE:     code_pgm[pc++]=CMDE_IDLE;
                                a=0;
                                if ((*x).dc1) a|=0x01;
                                if ((*x).dc2) a|=0x02;
                                if ((*x).stepper) a|=0x04;
                                code_pgm[pc++]=a;
                                break;

            case LABEL:         break;      // cette instruction ne gnere pas de code

            default:            msg="Erreur de logique interne (Code inconnu:"+AnsiString((*x).type)+")";
                                ListBox1->Items->Add(msg);
            }
        }
    }

if (SaveDialog2->Execute())
    {
    dest=fopen(SaveDialog2->FileName.c_str(),"wt");
    msg=ExtractFileDir(Application->ExeName)+"\\robot.hxx";
    hex=fopen(msg.c_str(),"rt");
    if ((dest)&&(hex))
        {
        // recopie le contenu du fichier  hxx

        while(fgets(buff,128,hex))
            {
            fputs(buff,dest);
            }
            
        // ajoute les datas issues du programme
        for (i=0;i<8;i++)
            {
            buff[2*i]=(unsigned char)(pgm_start[i]/256);
            buff[2*i+1]=(unsigned char)(pgm_start[i]&0x00ff);
            }
        traite(buff,0x7f00,dest);

        for (i=0;i<8;i++)
            {
            buff[2*i]=(unsigned char)(pgm_start[i+8]/256);
            buff[2*i+1]=(unsigned char)(pgm_start[i+8]&0x00ff);
            }
        traite(buff,0x7f10,dest);

        j=0;
        org=0x8000;
        for (i=0;i<0x8000;i++)
            {
            buff[j++]=code_pgm[i];
            if (j==16)
                {
                traite(buff,org,dest);
                j=0;
                org=i+1+0x8000;
                }
            }
        fprintf(dest,":00000001FF\n");
        }
    else
        {
        if (!hex)  Application->MessageBox("Impossible d'ouvrir le fichier 'robot.hxx'","Erreur d'ouverture du fichier",MB_OK|MB_ICONERROR);
        if (!dest) Application->MessageBox("Impossible de crer le fichier demand","Erreur d'ouverture du fichier",MB_OK|MB_ICONERROR);
        }
    fclose(dest);
    fclose(hex);
    }
delete code_pgm;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::BuildLabelListe(void)
{
list<item>::iterator x;
int i,pc;
AnsiString msg;
label l;

// contruit la liste des labels avec leur valeur
pc=0;                   // origine dans le tableau
liste_des_labels.clear();

for (i=0;i<16;i++)      // scan tout les programmes
    {
    for (x=pgm[i].begin();x!=pgm[i].end();x++)
        {
        if (pc>0x7fff)
            {
            msg="La taille des programmes dpasse les capacits de la mmoire de l'appareil";
            ListBox1->Items->Add(msg);
            return;
            }
        switch((*x).type)
            {
            case CMDE_END:      pc+=1;
                                break;
            case CMDE_STOP:     pc+=2;
                                break;
            case CMDE_STEPPER:  pc+=3;
                                break;
            case CMDE_MOT:      pc+=2;
                                break;
            case WAIT:          pc+=3;
                                break;
            case CALL:          pc+=3;
                                break;
            case RETURN:        pc+=1;
                                break;
            case JUMP:          pc+=3;
                                break;
            case DBG:           pc+=2;
                                break;
            case CMDE_IDLE:     pc+=2;
                                break;
            case LABEL:         l.txt=(*x).label;
                                l.pc=pc;
                                liste_des_labels.push_back(l);
                                break;
            default:            msg="Erreur de logique interne (Code inconnu:"+AnsiString((*x).type)+")";
                                ListBox1->Items->Add(msg);
                                return;
            }
        }
    }
}


//---------------------------------------------------------------------------
bool __fastcall TForm1::FindLabelValue(char * s, unsigned int &val)
{
list<label>::iterator x;
for (x=liste_des_labels.begin();x!=liste_des_labels.end();x++)
    {
    if (strcmp(s,(*x).txt.c_str())==0)
        {
        val=(*x).pc;
        return(true);
        }
    }
return(false);
}


//---------------------------------------------------------------------------

#define xw  p->PageWidth
#define yw  p->PageHeight
#define prt p->Canvas
#define hline   0.012
#define COL1    0.075*xw

//---------------------------------------------------------------------------
void __fastcall TForm1::Imprimerlepgmencours1Click(TObject *Sender)
{
int i;

i=ComboPgm->ItemIndex;
if (i<0)
    {
    Application->MessageBox("Selectionnez un numro de programme","Erreur de saisie",MB_OK|MB_ICONERROR);
    return;
    }

p=Printer();
PrintPage=1;
p->BeginDoc();
p->Title="Wrobotik1";

PrtTitle("Programme:"+IntToStr(i),COL1,PrtYpos*yw);
PrtNewLine();
PrtPgm(i);
p->EndDoc();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::PrtMsg(AnsiString msg,int xpos, int ypos)
{
TFontStyles x;
prt->Font->Name="Arial";
prt->Font->Size=8;
prt->Font->Style=x;
prt->TextOut(xpos,ypos,msg);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::PrtTitle(AnsiString msg,int xpos, int ypos)
{
TFontStyles x;
prt->Font->Name="Arial";
prt->Font->Size=10;
x<<fsBold;
prt->Font->Style=x;
prt->TextOut(xpos,ypos,msg);
PrtYpos+=hline;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::PrtNewLine(void)
{
PrtYpos+=hline;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::PrtPgm(int i)
{
list<item>::iterator x;

AnsiString msg;

for (x=pgm[i].begin();x!=pgm[i].end();x++)
    {
    switch((*x).type)
        {
        case    CMDE_MOT:  // mise en route des moteurs DC
                    msg="Moteur :";
                    if ((*x).dc1)
                        {
                        if ((*x).sens_dc1) msg+=" DC1(+)";
                        else msg+=" DC1(-)";
                        }
                    if ((*x).dc2)
                        {
                        if ((*x).sens_dc2) msg+=" DC2(+)";
                        else msg+=" DC2(-)";
                        }
                    break;

        case    CMDE_STEPPER:  // mise en route du moteur pas  pas
                    msg=AnsiString("Pas  pas : ")+IntToStr((*x).step)+" (t="+IntToStr((*x).speed)+" ms entre les pas)";
                    break;

        case    CMDE_STOP:  //Arrets des moteurs
                    msg="Arret :";
                    if ((*x).dc1) msg+=" DC1";
                    if ((*x).dc2) msg+=" DC2";
                    if ((*x).stepper) msg+=" Pas  pas";
                    break;

        case    CMDE_IDLE:  // Mise en roue libre des moteurs
                    msg="Roue libre :";
                    if ((*x).dc1) msg+=" DC1";
                    if ((*x).dc2) msg+=" DC2";
                    if ((*x).stepper) msg+=" Pas  pas";
                    break;

        case    WAIT:  // Attente d'un dlais
                    msg="Attente : "+AnsiString((*x).delais)+" (ms)";
                    break;

        case    LABEL:  // Dfinir un label
                    msg="Label: "+AnsiString((*x).label);
                    break;

        case    CALL:  // Appel d'un sous programme
                    msg="Appel sous pgm :"+AnsiString((*x).label);
                    break;

        case    RETURN:  //Retour de sous programme
                    msg="Retour de sous pgm";
                    break;

        case    JUMP:  // saut inconditionnel
                    msg="Saut en :"+AnsiString((*x).label);
                    break;

        case    DBG:  // Passage en mode debug
                    msg="Passage en mode debug = "+ AnsiString(((*x).debug ? "On" : "Off"));
                    break;

        case    CMDE_END:  // Fin de programme
                    msg="Fin";
                    break;
        default:        msg="Erreur de logique interne (Code inconnu:"+AnsiString((*x).type)+")";
                    PrtMsg(msg,COL1,PrtYpos*yw);
                    break;
        }
    PrtMsg(msg,COL1,PrtYpos*yw);
    PrtNewLine();
    }
}

void __fastcall TForm1::Imprimertouslespgms1Click(TObject *Sender)
{
int i;

p=Printer();
PrintPage=1;
p->BeginDoc();
p->Title="Wrobotik1";

for (i=0;i<16;i++)
    {
    if (pgm[i].size())
        {
        PrtTitle("Programme:"+IntToStr(i+1),COL1,PrtYpos*yw);
        PrtNewLine();
        PrtPgm(i);
        PrtNewLine();
        }
    }
p->EndDoc();
}
//---------------------------------------------------------------------------

void traite(char * trame,unsigned int org, FILE *d)
{
unsigned char checks;
int n;
bool vide=true;

// vrifie si la trame ne contient que des FF
for (n=0;n<16;n++)
    {
    if ((unsigned char)trame[n]!=0xff) vide=false;
    }
if (vide) return;

// traite la trame car elle contient des donnes
fprintf(d,":10%04X00",org);
checks=16;  // dbute avec la longueur
checks+=(unsigned char)((unsigned char)(org>>8)+(unsigned char)(org & 0x00ff));

for (n=0;n<16;n++)
    {
	checks+=trame[n];
	fprintf(d,"%02X",(unsigned char)trame[n]);
	}
checks=(unsigned char)((~checks)+1);
fprintf(d,"%02X\n",checks);
}


