// *****************************************************************************
// Module de tlchargement
// *****************************************************************************
#include <stdio.h>
#include "flash.h"
#include "getchar.h"


// *****************************************************************************
bit boot(void)
{
char i,a;
unsigned int x;

// ------------------------------------------------------------------
// efface les 3 blocs de mmoire flash allant de 0x4000  0xffff
// ------------------------------------------------------------------
for (i=2;i<4;i++)		
	{
	if(!erase_block_flash(i))
		{
		putchar('!');
		return(0);
		}
	}
putchar('.');

// ------------------------------------------------------------------
// programme le tableau  des pointeurs sur le debut des programmes
// ------------------------------------------------------------------
for (x=0;x<32;x++)
	{
	a=getchar();
	if (timeout)
		{
		putchar('!');
		return(0);
		}
	prog_byte_flash(a,0x7F00+x);
	putchar('.');
	}


// ------------------------------------------------------------------
// programme la zone des donnes
// ------------------------------------------------------------------
for (x=0;x<0x8000;x++)
	{
	a=getchar();
	if (timeout)
		{
		putchar('!');
		return(0);
		}
	prog_byte_flash(a,0x8000+x);
	putchar('.');
	}

return(1);
}



