// *****************************************************************************
// Gestion des fonctions de chronometre
// (C) Morin Pascal 2001-2002
// *****************************************************************************

#include <reg51f.h>
#include "chrono.h"


// *****************************************************************************
// variables globales du module
// *****************************************************************************
bit chrono_to_do=0;
unsigned int chrono_count;
bit rebours_to_do=0;
unsigned int rebours_count;


// *****************************************************************************
// fonctions du module
// *****************************************************************************
void start_rebours(unsigned int x)
{
rebours_count=x;
rebours_to_do=1;
}

// *****************************************************************************
void start_chrono(void)
{
chrono_count=0;
chrono_to_do=1;
}

// *****************************************************************************
void stop_chrono(void)
{
chrono_to_do=0;
}


// *****************************************************************************
unsigned int get_chrono(void)
{
unsigned int x;
EA=0;
x=chrono_count;
EA=1;
return(x);
}


// *****************************************************************************
// fonctions appele sous controle du gestionnaire d'interruption
// *****************************************************************************
void gere_chrono(void)
{
if (rebours_to_do)
	{
	rebours_count--;
	if (rebours_count) return;
	rebours_to_do=0;
	}
if (chrono_to_do)
	{
	chrono_count++;
	if (chrono_count!=0xffff) return;
	chrono_to_do=0;
	}
}

