//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>

//---------------------------------------------------------------------------
class label
{
public:
AnsiString txt;
unsigned int pc;
};

//---------------------------------------------------------------------------
class item
{
public:
int type;           // type de l'item
unsigned int ligne; // n de la ligne du pas de programme
char step;          // nb de pas pour le moteur pas  pas
unsigned char speed;// temps (en ms) entre les pas
bool dc1;           // indique si le moteur DC1 est concern
bool sens_dc1;      // sens pour le moteur DC1
bool dc2;           // indique si le moteur DC2 est concern
bool sens_dc2;      // sens pour le moteur DC2
bool stepper;       // indique si le moteur pas  pas est concern
unsigned int delais;// delai d'attente (en ms)
char label[41];     // label du pas de programme
bool debug;         // mode debug ON/OFF
};

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// Composants grs par l'EDI
    TMainMenu *MainMenu1;
    TMenuItem *Fichier1;
    TMenuItem *Ouvrir1;
    TMenuItem *Ouvrir2;
    TMenuItem *N1;
    TMenuItem *Enregistrersous1;
    TMenuItem *N2;
    TMenuItem *Quitter1;
    TRadioGroup *RadioAction;
    TGroupBox *GroupParam;
    TListBox *ListBox1;
    TComboBox *ComboPgm;
    TButton *Button1;
    TButton *Button2;
    TEdit *EditNbPas;
    TCheckBox *CheckDC1;
    TCheckBox *CheckDC2;
    TCheckBox *CheckStepper;
    TEdit *EditDelais;
    TEdit *EditLabel;
    TLabel *LabelLabel;
    TLabel *LabelDelais;
    TLabel *LabelNbPas;
    TRadioButton *RadioON;
    TRadioButton *RadioOFF;
    TRadioGroup *RadioDC1;
    TRadioGroup *RadioDC2;
    TLabel *LabelDebug;
    TSaveDialog *SaveDialog1;
    TOpenDialog *OpenDialog1;
    TMenuItem *Aide1;
    TMenuItem *Apropos1;
    TMenuItem *Compilation1;
    TMenuItem *Verifier1;
    TMenuItem *Compiler1;
    TSaveDialog *SaveDialog2;
    TEdit *EditSpeed;
    TLabel *LabelSpeed;
    TLabel *LabelSpeed2;
    TMenuItem *N3;
    TMenuItem *Imprimerlepgmencours1;
    TMenuItem *Imprimertouslespgms1;
    TLabel *Label1;
    TToolBar *ToolBar1;
    TToolButton *ToolButton1;
    TToolButton *ToolButton2;
    TToolButton *ToolButton3;
    TToolButton *ToolButton4;
    TToolButton *ToolButton5;
    TToolButton *ToolButton6;
    TToolButton *ToolButton7;
    TToolButton *ToolButton8;
    TToolButton *ToolButton9;
    TToolButton *ToolButton10;
    TToolButton *ToolButton11;
    TToolButton *ToolButton15;
    TImageList *ImageList1;
    void __fastcall Quitter1Click(TObject *Sender);
    void __fastcall RadioActionClick(TObject *Sender);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall Button2Click(TObject *Sender);
    void __fastcall ComboPgmChange(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall Enregistrersous1Click(TObject *Sender);
    void __fastcall Ouvrir1Click(TObject *Sender);
    void __fastcall Ouvrir2Click(TObject *Sender);
    void __fastcall Apropos1Click(TObject *Sender);
    void __fastcall Verifier1Click(TObject *Sender);
    void __fastcall Compiler1Click(TObject *Sender);
    void __fastcall Imprimerlepgmencours1Click(TObject *Sender);
    void __fastcall Imprimertouslespgms1Click(TObject *Sender);
private:	// Dclarations de l'utilisateur
public:		// Dclarations de l'utilisateur
    __fastcall TForm1(TComponent* Owner);
    void __fastcall AddListbox(item, int);
    void __fastcall RedrawList(void);
    bool __fastcall SaveFile(AnsiString dest);
    bool __fastcall OpenFile(AnsiString src);
    void __fastcall BuildLabelListe(void);
    bool __fastcall FindLabelValue(char * s, unsigned int &val);
    void __fastcall PrtNewLine(void);
    void __fastcall PrtTitle(AnsiString msg,int xpos, int ypos);
    void __fastcall PrtMsg(AnsiString msg,int xpos, int ypos);
    void __fastcall PrtPgm(int i);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
