// *****************************************************************************
// Entete du module de gestion des moteurs pas  pas
// (C) Morin Pascal 2001 -2002
// *****************************************************************************

#ifndef STEPPER
#define STEPPER

enum {STEP_PHASE1=0, STEP_PHASE2, STEP_PHASE3, STEP_PHASE4};

// *****************************************************************************
// variables globales du module
// *****************************************************************************

extern unsigned char 	state_a;
extern int 		   		count_a;
extern unsigned char 	speed_a;
extern unsigned char 	time_a;
extern bit		   		over_a;


// *****************************************************************************
// dfintion des ports utiliss par le module
// *****************************************************************************

extern bit step1;
extern bit step2;
extern bit step3;
extern bit step4;
extern bit en1;
extern bit en2;
extern bit en3;
extern bit en4;
extern bit m1a;
extern bit m1b;
extern bit m2a;
extern bit m2b;


// *****************************************************************************
// prototypes des fonctions du module
// *****************************************************************************
void init_stepper(void);
void gere_stepper(void);

void step_motor_a(char x);
void stop_motor_a(void);
void speed_motor_a(unsigned char x);

#endif



